#include "mpi.h"
#include <stdio.h>
 
int main(int argc, char *argv[])
{
    int myid, numprocs, left, right;
    int buffer[10], buffer2[10];
    int i = 0;
    MPI_Request request;
    MPI_Status status;
 
    MPI_Init(&argc,&argv);
    MPI_Comm_size(MPI_COMM_WORLD, &numprocs);
    MPI_Comm_rank(MPI_COMM_WORLD, &myid);
 
    right = (myid + 1) % numprocs;
    left = myid - 1;
    if (left < 0)
        left = numprocs - 1;
 
    if (myid == 1){
      for (i=0; i < 10; i++){ 
        buffer[i] = i+1;
      }   
    }

    for (i=0; i < 10; i++){
      buffer2[i] = -1;
    }

    MPI_Sendrecv(buffer, 10, MPI_INT, left, 123, buffer2, 10, MPI_INT, right, 123, MPI_COMM_WORLD, &status);

    if (myid == 2){
      for (i=0; i < 10; i++){
        printf("%d\n", buffer2[i]);
      }
    }
     

    printf("Hello from processor %d:  Left = %d\n", myid, left);
    printf("Hello from processor %d:  Right = %d\n", myid, right);
 
    MPI_Finalize();
    return 0;
}
